<script lang="ts">
  import Manager from "$lib/controller/Manager";
  import { notificationStore } from "$lib/stores/clientNotification.store";
  import { authTokenGithub } from "$lib/stores/githubResults.store";
  import { searchConfig } from "$lib/stores/searchConfig.store";
  import { search } from "$lib/stores/searchConfigStore";
  import { NotificationType } from "$lib/types/clientNotification.type";
  import { searchTerm } from "./ViewController";
  import GithubResults from "./components/GithubResults.svelte";
  import Logos from "./components/Logos.svelte";
  import ExtendedSearchOptions from "./components/extendedSearch/ExtendedSearchOptions.svelte";
  import SearchBar from "./components/extendedSearch/SearchBar.svelte";
  import Link from "$lib/Link.svelte";
  import DialogButton from "$lib/DialogButton.svelte";
  import Info from "./components/Info.svelte";
  import SetTokenDialogButton from "./components/SetTokenDialogButton.svelte";
  import DfgCredits from "./components/DFGCredits.svelte";
  import { onMount } from "svelte";
  import Button from "@smui/button";

  let showResultsFlag = false;

  const submitSearch = () => {
    if ($authTokenGithub !== "") {
      Manager.search(
        $searchTerm +
          $searchConfig
            .map((option) => `${option.name}:"${option.value}"`)
            .join(" ")
      );
      showResultsFlag = true;
    } else {
      notificationStore.set({
        type: NotificationType.error,
        title: "Github Error",
        message: "Please enter a Github token in the settings first.",
      });
    }
  };

  let totalVisits: number;
  async function fetchTotalVisits() {
    const response = await fetch("/visits");
    const data = await response.json();
    totalVisits = data.totalVisits;
  }
  onMount(fetchTotalVisits);
</script>

<Logos />

<SearchBar
  bind:value={$searchTerm}
  state={$search.state}
  doSearch={submitSearch}
  stopSearch={Manager.setGlobalStop}
/>

<div class="flex justify-center max-w-2xl mx-auto mt-3">
  <ExtendedSearchOptions state={$search.state} />
</div>

{#if $search.error.length > 0}
  <div class="flex justify-center">
    <p>{$search.error}</p>
  </div>
{/if}

{#if showResultsFlag}
  <GithubResults />
{/if}

<div class="flex flex-col py-8">
  <div class="flex justify-center w-3/4 mx-auto">
    <div class="flex-1 justify-center flex">
      <Link
        href={"https://preprints.inggrid.org/repository/view/16/"}
        data-test="link-paper"
      >
        Link to our Paper
      </Link>
    </div>

    <div class="flex-1 justify-center flex">
      <Link
        href="https://gitlab.com/tuc-isse/public/betty-research-engine/"
        data-test="link-gitlab"
      >
        Link to our GitLab
      </Link>
    </div>

    <div class="flex-1 justify-center flex">
      <DialogButton
        title="Info"
        label="How does this work?"
        data-test="button-tutorial"
      >
        <Info />
      </DialogButton>
    </div>
  </div>

  <div class="flex justify-center">
    {#if totalVisits}
      <h3 class="text-green-700">You are page visitor #{totalVisits}!</h3>
    {/if}
  </div>

  <div class="flex justify-center py-6">
    <SetTokenDialogButton />
  </div>

  <p class="flex flex-row items-center self-center">
    <Button
      href="https://hub.docker.com/r/bettyresearchengine/bettys-research-engine"
      target="_blank"
      data-test="link-docker"
    >
      <img
        class="w-7 mx-1"
        src="images/01-symbol_blue-docker-logo.png"
        alt="Docker Logo"
      />
      Docker Hub
    </Button>
  </p>
</div>

<DfgCredits />
